#ifndef _4GEWINNT
#define _4GEWINNT

#include <stdio.h>
#include <map>
#include <math.h>

#ifndef MAX
#define MAX(x,y) ((x)<(y)?(y):(x))
#endif
#ifndef MIN
#define MIN(x,y) ((x)<(y)?(x):(y))
#endif
#ifndef ABS
#define ABS(x) ((x)<0?-(x):(x))
#endif
#ifndef SGN
#define SGN(x) ((x)==0?0:((x)>0?1:-1))
#endif

#define FIELD_W 7
#define FIELD_H 6

#define FAKTOR ((int)pow(2,FIELD_H))

#define InField(a,b) ((a) >= 0 && (a) < FIELD_W && (b) >= 0 && (b) < FIELD_H)

#define POINTS_WIN 1000


#define HASHTABLE


struct _4Gewinnt
{
    public:
    int field[FIELD_W][FIELD_H];
    int player;
    #ifdef HASHTABLE
    std::map<unsigned long,int> hash;
    #endif
    _4Gewinnt();
    void _4Gewinnt::Clear();
    
    int Move(int move);
    int Undo(int move);
    int NextHole(int column);
    
    unsigned long GetHashCode();
    
    int DoMove();
    int Max(int depth, int maxdepth);
    int Min(int depth, int maxdepth);
    
    int Rate();  
};

#endif
